//
//  Winmail.h
//  TNEFsEnough3
//
//  Created by Josh Jacob on 5/27/11.
//  Copyright 2011 Josh Jacob. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <WebKit/WebKit.h>

@class LibytnefHelper;
@class FileTableViewDataSource;

@interface Winmail : NSDocument <NSTableViewDelegate, NSStreamDelegate> {
@private
    
    LibytnefHelper * tnefHelper;
    
    // table view data source
    FileTableViewDataSource * fileDataSource;
    
    // view outlets
    NSTextField *fieldFrom;
    NSTextField *fieldSubject;
    NSTextField *fieldDate;
    NSTableView *tableFiles;
    NSTextView *fieldBody;
    NSScrollView *fieldBodyScrollView;
    WebView *webview;
    NSBox *webViewBox;
    
    // print view outlets
    NSView *printView;
    NSTextField *printFieldFrom;
    NSTextField *printFieldSubject;
    NSTextField *printFieldDate;
    NSTextView *printFieldBody;
    WebView *printWebview;
    
    // export
    BOOL exportOne;
    NSURL * exportFile;
    NSURL * exportDir;
    NSMutableArray *exportArray;
    NSOutputStream *outputStream;
    
    // sheet
    NSWindow *savingSheet;
    NSTextField *savingSheetLabel;
    NSProgressIndicator *savingSheetProgress;
}

@property (nonatomic, retain) LibytnefHelper * tnefHelper;

@property (nonatomic, retain) IBOutlet FileTableViewDataSource * fileDataSource;

@property (assign) IBOutlet NSTextField *fieldFrom;
@property (assign) IBOutlet NSTextField *fieldSubject;
@property (assign) IBOutlet NSTextField *fieldDate;
@property (assign) IBOutlet NSTableView *tableFiles;
@property (assign) IBOutlet NSTextView *fieldBody;
@property (assign) IBOutlet NSScrollView *fieldBodyScrollView;
@property (assign) IBOutlet WebView *webview;
@property (assign) IBOutlet NSBox *webViewBox;

@property (assign) IBOutlet NSView *printView;
@property (assign) IBOutlet NSTextField *printFieldFrom;
@property (assign) IBOutlet NSTextField *printFieldSubject;
@property (assign) IBOutlet NSTextField *printFieldDate;
@property (assign) IBOutlet NSTextView *printFieldBody;
@property (assign) IBOutlet WebView *printWebview;

@property (nonatomic, retain) NSURL * exportFile;
@property (nonatomic, retain) NSURL * exportDir;
@property (nonatomic, retain) NSMutableArray *exportArray;
@property (nonatomic, retain) NSOutputStream *outputStream;
@property (assign) IBOutlet NSWindow *savingSheet;
@property (assign) IBOutlet NSTextField *savingSheetLabel;
@property (assign) IBOutlet NSProgressIndicator *savingSheetProgress;

- (IBAction) exportSelectedAttachment: (id) sender;
- (void) kickOffExport;
- (IBAction) exportAll: (id) sender;
- (void) exportSet: (NSArray *) rows;
- (void) kickOffExportAll;
- (void) kickOffExportAllNext;

@end
